import sys 
import time
import navio.rcinput
import navio.util
import rticonnextdds_connector as rti
import threading
from sys import path as sysPath
from os import path as osPath

filepath = osPath.dirname(osPath.realpath(__file__))
sysPath.append(filepath + "/../../../")
sem = threading.Semaphore()
control=0
motorderecho=1.5
motorizquierdo=1.5
run=1
def controlWriter():
    print("1")
    global control,run
    try:
        sem.acquire(True)
        print("entra control")
        connector1 = rti.Connector("UserParticipantLibrary::ControlPublisher",
                          filepath + "/../dds.xml")
        outputDDS = connector1.getOutput("MyControlPublisher::MyControlWriter")
        sem.release()
        print("sale control")
        while(run !=0):
            outputDDS.instance.setNumber("x", control)
            outputDDS.write()
            time.sleep(1)
    finally:
        connector1.delete()
        print("borrado conector 1")
    
    

def Velocitywriter():
    print("2")
    global motorderecho, motorizquierdo
    try:
        sem.acquire(True)
        print("entra velocity")
        connector2 = rti.Connector("UserParticipantLibrary::VelocityPublisher",
                          filepath + "/../dds.xml")
        outputDDS = connector2.getOutput("MyVelocityPublisher::MyVelocityWriter")
        sem.release()
        print("sale velocity")
        while(run !=0):
            outputDDS.instance.setNumber("x", float(motorderecho))
            outputDDS.instance.setNumber("y", float(motorizquierdo))
            outputDDS.write()
            time.sleep(1)
    finally:
        connector2.delete();
        print("borrado conector 2")
    
    



velocity = threading.Thread(target=Velocitywriter)
controlTheard = threading.Thread(target=controlWriter)


controlTheard.start()
velocity.start()

navio.util.check_apm()

#rcin = navio.rcinput.RCInput()
## insertar aqui programa de lectura de canales y procesado
centro = 900
valMax = 2000
ValMin = 500
direccionPal=1000
velocidadPal = 1000
try:
    while(1):
        #control = rcin.read(4) #
        #velocidadPal= rcin.read(3) #tratar este dato entre /1000
        #direccionPal= rcin.read(1) # 
        porcentderecha = (direccionPal - centro)/centro
        portentizquierda = (centro - direccionPal)/centro

        if(porcentderecha<0.05):
            porcentderecha=0
        if(portentizquierda<0.05):
            portentizquierda=0
        velocidad = velocidadPal/1000
        motorderecho = velocidad - velocidadPal*porcentderecha
        motorizquierdo = velocidad - velocidadPal*portentizquierda
        time.sleep(0.5)
finally:
    run = 0
    velocity.join()
    controlTheard.join()
    print("sale bien")

